/********************************************************************************
 Author        : ADI CAST  macduan 

 Date          : 2011-4-13

 Hardware      : ADuC7026+AD5380	
********************************************************************************/
#include<ADuC7026.h>
#include"ADuC7026_DRIVER.h"
#include"AD5380_IO.h"

//Delay;

void delay (int length)
{
	while (length >0)
    	length--;
}

/********************************************************************************
Function that writes to the AD5380 via the SPI port.
********************************************************************************/


void WriteToAD5380ViaSpi(long int RegisterData)
{

	long int ValueToWrite = RegisterData;
	int i;
	
	// SPI start

	SET_SYNC();
	delay(1);
	CLR_SYNC();	 //bring SYNC low
	delay(1);
	

	//Write out the ControlWord
	
	for(i=0; i<24; i++)
	{	
		SET_SCLK();
		delay(1);
		if(0x800000 == (ValueToWrite & 0x800000))
		{
			SET_SDIN();	  //Send one to DIN pin
		}
		else
		{
			CLR_SDIN();	  //Send zero to DIN pin
		}
		delay(1);
		CLR_SCLK();
		delay(1);
		ValueToWrite <<= 1;	//Rotate data
		delay(1);

	}
		

    // SPI ends

	
	SET_SYNC();
    delay(5);

}


/********************************************************************************
Function that read from the AD5380 via the SPI port.
********************************************************************************/


void ReadFromAD5380ViaSpi(long int *RegisterData)
{

	
	unsigned	int	    i = 0;
	unsigned	int  	iTemp = 0;
	unsigned	long  	RotateData = 0;

	unsigned	long  	Noop = NOP;

	// SPI start

	SET_SYNC();
	delay(1);
	CLR_SYNC();	 //bring SYNC low
	delay(1);

	for(i=0; i<24; i++)
	{
		SET_SCLK();
		delay(1);
//////////////////////////////////////////////////
	if(0x800000 == (Noop & 0x800000))
		{
			SET_SDIN();	  //Send one to SDI pin
		}
		else
		{
			CLR_SDIN();	  //Send zero to SDI pin
		}
//////////////////////////////////////////////////

		CLR_SCLK();
		delay(1);
			 
		iTemp = GP4DAT;			//Read DIN of AD736, P4.4->SDout
		RotateData <<= 1;
		
		if(0x00000010 == (iTemp & 0x00000010))
		{
	
			RotateData |= 1;
			
		}
		
		Noop <<= 1;
    	delay(5);		
	}

	 
	 					
    // SPI ends

	SET_SYNC();
 
    delay(2); 
	*RegisterData=RotateData;

}


void ComPortsToPC(long int buf)
{
	unsigned	char	tx[3] = {0,0,0};

//	tx[2] = ((buf)&0xFF0000)>>16;	
//	tx[1] = ((buf)&0x00FF00)>>8;
	tx[1] = ((buf)&0x003F00)>>8;	
	tx[0] = (buf)&0x000000FF;
	  
//	putchar(tx[2]); 
	putchar(tx[1]); 	 	//output the value to PC.
	putchar(tx[0]);   
}