/********************************************************************************
 Author        : ADI CAST  macduan 

 Date          : 2011-4-13

 Hardware      : ADuC7026+AD5380	
********************************************************************************/


/****************************************************
 * only spi and serial mode is selected 
 *  so the register configuration is 24bit as follows
 * |A/B | R/W | A5---A0 | REG1-REG0 | DB13---DB0|
 ****************************************************/

#ifndef AD5380_IO_H
#define AD5380_IO_H

//Data Resiter Selection,with toggle disable this bit should be set to 0
#define A_Data_Register (0x00<<23)
#define B_Data_Register	(0x01<<23)

//Write or Read slecetion
#define Read            (0x01<<22)
#define Write           (0x00<<22)

//REGISTER SELECTION
#define Input_Data_Register       ((0x01<<15)|(0x01<<14))
#define Offset_Register		       (0x01<<15)
#define Gain_Register              (0x01<<14)  //default is 0x3FFE
#define Special_Function_Register   0x00

//funtions while SFR is selected
#define NOP                         0x00
#define Write_CLR_Code             (0x01<<16)
#define Soft_CLR                   (0x01<<17)
#define SoftWare_PowerDown         (0x01<<19)
#define SoftWare_PowerUp          ((0x01<<19)|(0x01<<0))
#define Control_Register          ((0x01<<19)|(0x01<<18))   //default is 0x3000
#define Channel_Moniter           ((0x01<<19)|(0x01<<17))
#define SoftWare_Reset             (0x0F<<16)

//control bit of control register
#define PowerDown_High_Impedance    (0x01<<13) //default
#define PowerDown_100K_toGND        (0x00<<13)
#define Internal_REF_2_5            (0x01<<12) 
#define	Internal_REF_1_25           (0x00<<12)
#define Boost_Mode_On               (0x01<<11)
#define Boost_Mode_Off              (0x00<<11) //default
#define Internal_REF_Enabled        (0x01<<10) //when this ref is selected the pin is output of ref
#define External_REF_Selected       (0x00<<10) //default
#define Channel_Monitor_Enable      (0x01<<9)  //after a write to the monitor channel in the SFR 
#define Cannnel_Monitor_Disable	    (0x00<9)
#define Thermal_Monitor_Enable      (0x01<<8)
#define Thermal_Monitor_Disable     (0x00<<8)
#define toggle_32_29                (0x01<<6) //enable toggle mode
#define toggle_24_31                (0x01<<5)
#define toggle_16_23                (0x01<<4)
#define toggle_8_15                 (0x01<<3)
#define toggle_0_7                  (0x01<<2)

//DAC register channel selection
#define Channel_Vout0                (0x00<<16)
#define Channel_Vout1                (0x01<<16)
#define Channel_Vout2                (0x02<<16)
#define Channel_Vout3                (0x03<<16)
#define Channel_Vout4                (0x04<<16)
#define Channel_Vout5                (0x05<<16)
#define Channel_Vout6                (0x06<<16)
#define Channel_Vout7                (0x07<<16)
#define Channel_Vout8                (0x08<<16)
#define Channel_Vout9                (0x09<<16)
#define Channel_Vout10               (0x0A<<16)
#define Channel_Vout11               (0x0B<<16)
#define Channel_Vout12               (0x0C<<16)
#define Channel_Vout13               (0x0D<<16)
#define Channel_Vout14               (0x0E<<16)
#define Channel_Vout15               (0x0F<<16)
#define Channel_Vout16               (0x10<<16)
#define Channel_Vout17               (0x11<<16)
#define Channel_Vout18               (0x12<<16)
#define Channel_Vout19               (0x13<<16)
#define Channel_Vout20               (0x14<<16)
#define Channel_Vout21               (0x15<<16)
#define Channel_Vout22               (0x16<<16)
#define Channel_Vout23               (0x17<<16)
#define Channel_Vout24               (0x18<<16)
#define Channel_Vout25               (0x19<<16)
#define Channel_Vout26               (0x1A<<16)
#define Channel_Vout27               (0x1B<<16)
#define Channel_Vout28               (0x1C<<16)
#define Channel_Vout29               (0x1D<<16)
#define Channel_Vout30               (0x1E<<16)
#define Channel_Vout31               (0x1F<<16)
#define Channel_Vout32               (0x20<<16)
#define Channel_Vout33               (0x21<<16)
#define Channel_Vout34               (0x22<<16)
#define Channel_Vout35               (0x23<<16)
#define Channel_Vout36               (0x24<<16)
#define Channel_Vout37               (0x25<<16)
#define Channel_Vout38               (0x26<<16)

//channel monitor enable
#define  Monitor_Enable              (0x01<<9)
#define  Monitor_Disable			 (0x00<<9)


//monitor output selection
#define Monitor_Vout0                (0x00<<8)
#define Monitor_Vout1                (0x01<<8)
#define Monitor_Vout2                (0x02<<8)
#define Monitor_Vout3                (0x03<<8)
#define Monitor_Vout4                (0x04<<8)
#define Monitor_Vout5                (0x05<<8)
#define Monitor_Vout6                (0x06<<8)
#define Monitor_Vout7                (0x07<<8)
#define Monitor_Vout8                (0x08<<8)
#define Monitor_Vout9                (0x09<<8)
#define Monitor_Vout10               (0x0A<<8)
#define Monitor_Vout11               (0x0B<<8)
#define Monitor_Vout12               (0x0C<<8)
#define Monitor_Vout13               (0x0D<<8)
#define Monitor_Vout14               (0x0E<<8)
#define Monitor_Vout15               (0x0F<<8)
#define Monitor_Vout16               (0x10<<8)
#define Monitor_Vout17               (0x11<<8)
#define Monitor_Vout18               (0x12<<8)
#define Monitor_Vout19               (0x13<<8)
#define Monitor_Vout20               (0x14<<8)
#define Monitor_Vout21               (0x15<<8)
#define Monitor_Vout22               (0x16<<8)
#define Monitor_Vout23               (0x17<<8)
#define Monitor_Vout24               (0x18<<8)
#define Monitor_Vout25               (0x19<<8)
#define Monitor_Vout26               (0x1A<<8)
#define Monitor_Vout27               (0x1B<<8)
#define Monitor_Vout28               (0x1C<<8)
#define Monitor_Vout29               (0x1D<<8)
#define Monitor_Vout30               (0x1E<<8)
#define Monitor_Vout31               (0x1F<<8)
#define Monitor_Vout32               (0x20<<8)
#define Monitor_Vout33               (0x21<<8)
#define Monitor_Vout34               (0x22<<8)
#define Monitor_Vout35               (0x23<<8)
#define Monitor_Vout36               (0x24<<8)
#define Monitor_Vout37               (0x25<<8)
#define Monitor_Vout38               (0x26<<8)











#endif



