/********************************************************************************
 Author        : ADI CAST  macduan 

 Date          : 2011-4-13

 Hardware      : ADuC7026+AD5380	
********************************************************************************/
#include<ADuC7026.h>
#include"ADuC7026_DRIVER.h"
#include"AD5380_IO.h"


void putchar(unsigned char ch)    //Write character to Serial Port 
{          
	COMTX = ch;				 //COMTX is an 8-bit transmit register.
    while(!(0x020==(COMSTA0 & 0x020)))
    {;}
}


void ADuC7026_Initiate(void)
{
   /* PLLKEY1 = 0xAA;
	PLLCON  = 0x01;
	PLLKEY2 = 0x55;				//external crystal
   */

	//set core clock 
	POWKEY1=0x01;
	POWCON=0x00;				   //core clock=41.78MHz,CD bit=0
	POWKEY2=0xF4;

	GP4DAT = (GP4DAT | 0xEFEF0000);	   //Config All as outputs, except P4.4 as input; P4.0~P4.3, P4.6 set to 1))
	GP2DAT = (GP2DAT | 0x08080000);	   //Config P2.3 as output, set to 1;	
    
	//Start setting up UART at 9600bps
	COMCON0 = 0x80;					// Setting DLAB

	COMDIV0 = 0x85;				//9600bps
   	COMDIV1 = 0x00;
   	COMCON0 = 0x07;					// Clearing DLAB

				
	//Configure UART;


	GP1CON = 0x00000011;			//P1.0 as SIN,P1.1 as SOUT
	GP0CON = (GP0CON | 0x10000000);

}  
