/********************************************************************************
 Author        : ADI CAST  macduan 

 Date          : 2011-4-13

 Hardware      : ADuC7026+AD5380	
********************************************************************************/
#include<ADuC7026.h>
#include"ADuC7026_DRIVER.h"
#include"AD5380_IO.h"

int main()
{
	long int cstr = 0;

	long int buf  = 0;
				 	
	ADuC7026_Initiate();

	//-------------------------------------------------------------------------------------
	//Enable monitor and internal REF to 1.25v and select power down mode that is 100k_GND
	//-------------------------------------------------------------------------------------

	cstr = Write | Special_Function_Register | Control_Register  | Monitor_Enable | Internal_REF_Enabled | Internal_REF_1_25 | PowerDown_100K_toGND;
	WriteToAD5380ViaSpi(cstr);

	//---------------------------------------------------------------------------------
	// Vout = 2 * Gain * Vref; Vref is 2.5 default and can be selected to 1.25 internal
	//---------------------------------------------------------------------------------

	cstr = Write | Input_Data_Register | Channel_Vout3   | 0x003FFF;  //Vout3 IS 2.51
	WriteToAD5380ViaSpi(cstr);

	cstr = Write | Input_Data_Register | Channel_Vout36  | 0x002000;  //Vout36 IS 1.25V
	WriteToAD5380ViaSpi(cstr);

	cstr = Write | Input_Data_Register | Channel_Vout6   | 0x001000;  //Vout36 IS 0.629V
	WriteToAD5380ViaSpi(cstr);
	
	cstr = Write | Special_Function_Register | Channel_Moniter | Monitor_Vout36;  
	WriteToAD5380ViaSpi(cstr);
		                  	 

//-----------------------------------------------------------------------------
//readback data of selected DAC Register,which can be seen using CommAssistant 
//-----------------------------------------------------------------------------
	delay(2);

	cstr = Read | Special_Function_Register | Control_Register;	// readback control register data 
	WriteToAD5380ViaSpi(cstr);	                  	 

	ReadFromAD5380ViaSpi(&buf);	  //Read select register, using two instruction cycles 
	ComPortsToPC(buf);            //transfer data to pc through com ports		
	
	cstr = Read | Special_Function_Register | Gain_Register;	// readback Gain register data 
	WriteToAD5380ViaSpi(cstr);	                  	 

	ReadFromAD5380ViaSpi(&buf);	  //Read select register, using two instruction cycles 
	ComPortsToPC(buf);            //transfer data to pc through com ports	
/*--------------------------------------------------------------------------------------------
 *	cstr = Write | Special_Function_Register | SoftWare_PowerDown;  // software powerdown
 *	WriteToAD5380ViaSpi(cstr);
 *
 *	cstr = Write | Special_Function_Register | SoftWare_PowerUp;  // software power up
 *	WriteToAD5380ViaSpi(cstr);
 *--------------------------------------------------------------------------------------------*/   

/*--------------------------------------------------------------------------------------------
 *	cstr = Write | Special_Function_Register | Write_CLR_Code | 0x3FFF;  // Write CLR data
 *	WriteToAD5380ViaSpi(cstr);
 *
 *	cstr = Write | Special_Function_Register | Soft_CLR;  // software CLR
 *	WriteToAD5380ViaSpi(cstr);
 *--------------------------------------------------------------------------------------------*/ 


 	while(1)
    {;}

	return 0;
}
